import java.awt.Toolkit;	// fr das Beepen (funkt bei mir aber nicht)
import javax.swing.text.*;	// fr das PlainDocument
import java.util.*;		// fr den Calendar
import java.text.*;        // fr das SimpleDateFormat

     /**
     * Version 1.2      (c) 2000 frank gehde     gehde@ag-intra.net
     * Dokument Modell, welches ein 10 stelliges Datenmodell nutzt, welches 
     * nur existierende Datumsangaben verwaltet. Trennzeichen werden untersttzt.
     * Schwache Validierung fr jede Stelle wird untersttzt.
     * Wird verwendet von der Klasse JDateField, die das JTextField
     * erweitert.
     **/
     
public class DateFieldDocument extends PlainDocument {
							// **** Attribute
	private static final String JAHR  = "0123456789";	// Erlaubte Ziffern Jahr
	private static final String DREI  = "0123";		// Erlaubte Ziffern Tag 10er
	private static final String MONAT = "01";		// Erlaubte Zeichen Monat 10er
	private Calendar initDate = new GregorianCalendar();	// Calender fuers init
	private String initString; 				// Voreingestellter String
	private static int trenner1 = 2, trenner2 = 5;		// Position vor dem Trenner
	private JTextComponent textComponent;			// Fr Referenz auf das TextFeld
	private int newOffset;					// Caret Position bei Trennern
	SimpleDateFormat datumsFormat = new SimpleDateFormat ("dd.MM.yyyy"); //Konv.
							// **** Attribute Ende

	public DateFieldDocument(JTextComponent textComponent) { // **** Konstruktor 1
		this.textComponent = textComponent;  		 // Hiermit wird jetzt gearbeitet
		initDate.setTime(new Date()); 			 // Kalender auf heute
		initString = datumsFormat.format(initDate.getTime()); // Nach String
		try {						 // Jetzt den Inhalt mit dem Datum
			insertString(0, initString, null);	 // initialisieren
		}
		catch(Exception KonstrEx) { KonstrEx.printStackTrace(); }
	}							 // **** Konstruktor 1 Ende

								 // **** Konstruktor 2
	public DateFieldDocument(JTextComponent textComponent, Calendar givenDate) { 

		this.textComponent = textComponent;  		 // Hiermit wird jetzt gearbeitet
		initDate=givenDate; 			 	 // Kalender auf Parameter
		initString = datumsFormat.format(initDate.getTime()); // Nach String
		try {						 // Jetzt den Inhalt mit dem Datum
			insertString(0, initString, null);	 // initialisieren
		}
		catch(Exception KonstrEx) { KonstrEx.printStackTrace(); }
	}							// **** Konstruktor 2 Ende

	public void insertString(int offset, String zeichen, 	// **** berschreiben Insert-Methode
							AttributeSet attributeSet) 
							throws BadLocationException {

		if(zeichen.equals(initString)) {		// Wenn initString, gleich rein
			super.insertString(offset, zeichen, attributeSet);
		}
		else if(zeichen.length()==10) {			// Wenn komplettes Datum, und
			if (JDateField.isDate(zeichen)) {	// richtig, dann rein
				super.remove(0, 10);
				super.insertString(0, zeichen, attributeSet);
			}
		}
		else if(zeichen.length()==1) {			// Wenn nicht, nur Einzelzeichen
			try {					// annehmen
				Integer.parseInt(zeichen);
			}
			catch(Exception NumEx) {		// Kein Integer? Keine Verarbeitung!
				return;
			}
			if(offset==0) {		// Tage auf 10 20 30 prfen  (Kleine Validation)
     				if( DREI.indexOf( zeichen.valueOf(zeichen.charAt(0) ) ) == -1 ) {
					Toolkit.getDefaultToolkit().beep();
					return;
				}
			}
			if(offset==1) {		// Tage 32-39 unterbinden  (Kleine Validation)
     				if(textComponent.getText().substring(0, 1).equals("3")) {
					int tag = new Integer(zeichen).intValue();
					if(tag>1) {
						Toolkit.getDefaultToolkit().beep();
						return;
					}
				}
			}
			if(offset==1) {		// Tag 00 unterbinden  (Kleine Validation)
     				if(textComponent.getText().substring(0, 1).equals("0")) {
					int tag = new Integer(zeichen).intValue();
					if(tag==0) {
						Toolkit.getDefaultToolkit().beep();
						return;
					}
				}
			}
			if(offset==2) {		// Monate auf 0x-1x prfen  (Caret links vom Trenner)
     				if( MONAT.indexOf( zeichen.valueOf(zeichen.charAt(0) ) ) == -1 ) {
					Toolkit.getDefaultToolkit().beep();
					return;
				}
			}
			if(offset==3) {		// Monate auf 0x-1x prfen  (Caret rechts vom Trenner)
     				if( MONAT.indexOf( zeichen.valueOf(zeichen.charAt(0) ) ) == -1 ) {
					Toolkit.getDefaultToolkit().beep();
					return;
				}
			}
			if(offset==4) {		// Monate 13-19 unterbinden  (Kleine Validation)
     				if(textComponent.getText().substring(3, 4).equals("1")) {
					int monat = new Integer(zeichen).intValue();
					if(monat>2) {
						Toolkit.getDefaultToolkit().beep();
						return;
					}
				}
			}
			if(offset==4) {		// Monat 00 unterbinden  (Kleine Validation)
     				if(textComponent.getText().substring(3, 4).equals("0")) {
					int monat = new Integer(zeichen).intValue();
					if(monat==0) {
						Toolkit.getDefaultToolkit().beep();
						return;
					}
				}
			}


			newOffset = offset;
			if(atSeparator(offset)) { 		// Wenn am trenner, dann den offset
				newOffset++;	  		// vor dem einfgen um 1 verschieben
				textComponent.setCaretPosition(newOffset);
			}
			super.remove(newOffset, 1); 		// Aktuelles zeichen entfernen
			super.insertString(newOffset, zeichen, attributeSet); // Neues einfgen
		}
	}							// **** berschreiben Insert Ende

	public void remove(int offset, int length) 		// **** berschreiben Remove
							throws BadLocationException {
		if(atSeparator(offset)) 
			textComponent.setCaretPosition(offset-1);
		else
			textComponent.setCaretPosition(offset);
	}							// **** berschreiben Remove Ende

	private boolean atSeparator(int offset) {		// **** Hilfsmethode fr die Punkte
		return offset == trenner1 || offset == trenner2;
	}							// **** Hilfsmethode Ende
}